<!DOCTYPE html>
<html lang="en">




<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- page title (site.title if page.title doesn't exist) -->
  <title>W4. Electronics production</title>

  <!-- site description (appears in Google etc.) or page.excerpt if defined -->
  <meta name="Comuputer" content="Aenean lacinia bibendum nulla sed consectetur. Etiam porta sem malesuada magna mollis euismod. Donec ullamcorper nulla non metus auctor fringilla. Vivamus sa...">

  <!-- import our stylesheet -->
  <link href="subpage.css" rel="stylesheet" type="text/css">





  <!-- load favicon -->
  <link rel="shortcut icon" type="image/png" href="/mdef-jekyll-starter/images/favicon.png" />


  <!-- canonical URLs for better SEO -->
  <link rel="
    canonical" href="http://localhost:4000/mdef-jekyll-starter/reflections/biology-zero/">
  <link rel="alternate" type="application/rss+xml" title="MDEF Jekyll starter" href="/mdef-jekyll-starter/feed.xml">
<!-- load css sytle sheet -->

<title> Input devices </title>
  <link href="style.css" rel="stylesheet" type="text/css">

</head>

<body>

<div class="container">
  <header class="header" role="banner">


        <div class="row" style="text-align:center;">

        <ul class="main-nav">


                    <li><a href="https://mdef.gitlab.io/adriana.tamargo/"> MDEF </a></li>
          <li><a href="https://mdef.gitlab.io/adriana.tamargo/Reflections.html"> First term </a></li>
          <li><a href="https://mdef.gitlab.io/adriana.tamargo/Secondterm.html"> Second term </a></li>
          <li class="active"><a href="https://mdef.gitlab.io/adriana.tamargo/FabAcademy.html"> Fab Academy </a></li>
          <li><a href="https://mdef.gitlab.io/adriana.tamargo/Finalproject.html"> Final project </a></li>
          <li><a href="https://mdef.gitlab.io/adriana.tamargo/Aboutme.html"> About me </a></li>
          <li> <h5> adriana.tamargo@iaac.net </h5> </li>
                </ul>

    </div>


  </header>

  <main class="page-content" aria-label="Content">
    <div class="wrapper">
    <h1 id="subheading-2">W10. Input devices</h1>

<p>This week we learned about different sensors or input devices and how we can retrieve analogue data into our microprocessors and read it. I partnered up with <a href="https://florezal754.gitlab.io/mdef-jekyll/FabAcademy/W10/W10.html"> Laura </a> and decided to try a distance sensor (sonar), the Ultrasonic HC-SR04. </p>

<h2 id="subheading-2">What is a distance sensor? </h2>


<p>A ultrasonic sensor is an instrument that measures the distance to an object using ultrasonic sound waves. It uses a transducer to send and receive ultrasonic pulses that relay back information about an object’s proximity. High-frequency sound waves reflect from boundaries to produce distinct echo patterns.</p>

<h2 id="subheading-2">Making the board </h2>

<p>We replicated a Neil's Board to make this assignment. For that, we downloaded the png file form here and added a "I" mark so we didn't mess up the input and output boards. For the production of the board we followed the same steps we followed in Electronics production week. </p>

<p> Once the board was milled, we soldered the components and checked if all the connections were working with the Amperimeter. We used the following components: </p>

<p> 1 x Attiny 45, 1 x 6 ipin Header AVRISPSMD, 1 x 1uF CAP-US1206FAB, 1 x 10k resistor, 1 x 6 pin Header FTDI, 1 x 4 pin Header FTDI. </p>

<img src="https://mdef.gitlab.io/adriana.tamargo/input1.jpg" width="800">

<h2 id="subheading-2"> Programming </h2>

<p> For programming we used the AVR ISP and the FTDI cable, following these steps: </p>

<p> 1) Once is solded, we checked the connections </p>
<p> 2) We connceted the AVR ISP to the board and the FTDI cable </p>
<p> ) After that, we connected the OUTPUT - Speaker to the board</p>
<p>) In the Arduino software, we changed the settings to work through the AVR ISP- to programm the board through it (when we did embedded programming we used a FAB ISP for programming the other FAB ISP) </p>

· Board: "ATtiny25/45/85" 
· Procesador: "ATtiny45" 
· Clock: "Internal 1 MHz" 
· Port: "COM4" 
· Programmer: "AVRISP mkII" 

<p> We followed <a href="https://naylampmechatronics.com/blog/10_Tutorial-de-Arduino-y-sensor-ultras%C3%B3nico-HC-S.html"> this tutorial </a> to read the sensor. For that, firwt we had to install <a href="https://zadig.akeo.ie/">the drivers for the bootloader </a> in order to programm the board. This was the main problem that we faced when programming it. Once it was installed it worked out perfectly. </p>

<img src="https://mdef.gitlab.io/adriana.tamargo/input2.jpg" width="750">
<img src="https://mdef.gitlab.io/adriana.tamargo/input3.jpg" width="750">
<img src="https://mdef.gitlab.io/adriana.tamargo/input4.jpg" width="750">
<img src="https://mdef.gitlab.io/adriana.tamargo/input5.jpg" width="750">

<p> Drivers installed successfully! </p>

<p> After installing the drivers, we facead another problem. The board was not working, the programmer light was green but we couldn't read anything from the sensor. After a while, we realized that the soldering of two components was slightyly together and we fixed the soldering. Finally the burning Bootloader didn't work at the first time programming with the AVRISP · Memory - Bytes: we were occuping more bytes than they were available. </p>



<p> Here I add the final code running with the serial: </p>

<img src="https://mdef.gitlab.io/adriana.tamargo/input7.jpg" width="750">
<img src="https://mdef.gitlab.io/adriana.tamargo/input6.gif" width="750">

<p> This is the final code we used for reading the sensor: </p>

<p> #include <SoftwareSerial.h>

SoftwareSerial mySerial(1, 2); // RX, TX

const int Trigger = 3;   //Pin digital 2 para el Trigger del sensor
const int Echo = 4;   //Pin digital 3 para el Echo del sensor

void setup() {
  mySerial.begin(9600);//iniciailzamos la comunicación
  pinMode(Trigger, OUTPUT); //pin como salida
  pinMode(Echo, INPUT);  //pin como entrada
  digitalWrite(Trigger, LOW);//Inicializamos el pin con 0
}

void loop()
{

  long t; //timepo que demora en llegar el eco
  long d; //distancia en centimetros

  digitalWrite(Trigger, HIGH);
  delayMicroseconds(10);          //Enviamos un pulso de 10us
  digitalWrite(Trigger, LOW);
  
  t = pulseIn(Echo, HIGH); //obtenemos el ancho del pulso
  d = t/59;             //escalamos el tiempo a una distancia en cm
  
  mySerial.print("Distancia: ");
  mySerial.print(d);      //Enviamos serialmente el valor de la distancia
  mySerial.print("cm");
  mySerial.println();
  // delay(300);          //Hacemos una pausa de 100ms
}

</p>

<h2> Files </h2>
<a href="https://gitlab.com/MDEF/adriana.tamargo/blob/master/input_code.ino"> Arduino code </a>


</div>

    </div>

  </div>



</article>
    </div>
  </main>

  <footer class="footer">

  <div class="row" style="text-align: center;">

      <ul class="main-nav">
        <li><a href="https://mdef.gitlab.io/adriana.tamargo/Computercontrolledcutting.html"> Previous post </a></li>
        <li><a href="https://mdef.gitlab.io/adriana.tamargo/3dprinting.html"> Next post </a></li>
        <li><h5>adriana.tamargo@iaac.net</h5></li>

    </div>

  </div>

    <div class="row" style="text-align: left;">

  </div>

</footer>

</body>

</html>
